'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactMoleculeField = require('@s-ui/react-molecule-field');

var _reactMoleculeField2 = _interopRequireDefault(_reactMoleculeField);

var _reactMoleculeSelect = require('@s-ui/react-molecule-select');

var _reactMoleculeSelect2 = _interopRequireDefault(_reactMoleculeSelect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hasErrors = function hasErrors(success, error) {
  if (error) return true;
  if (success) return false;
};

var MoleculeSelectField = function (_Component) {
  (0, _inherits3.default)(MoleculeSelectField, _Component);

  function MoleculeSelectField() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MoleculeSelectField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MoleculeSelectField.__proto__ || (0, _getPrototypeOf2.default)(MoleculeSelectField)).call.apply(_ref, [this].concat(args))), _this), _this.refSelect = _react2.default.createRef(), _this.handleClick = function () {
      var domSelect = _this.refSelect.current;

      if (domSelect) domSelect.focus();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MoleculeSelectField, [{
    key: 'render',
    value: function render() {
      var refSelect = this.refSelect,
          handleClick = this.handleClick;
      var _props = this.props,
          label = _props.label,
          id = _props.id,
          successText = _props.successText,
          errorText = _props.errorText,
          helpText = _props.helpText,
          inline = _props.inline,
          children = _props.children,
          props = (0, _objectWithoutProperties3.default)(_props, ['label', 'id', 'successText', 'errorText', 'helpText', 'inline', 'children']);

      var errorState = hasErrors(successText, errorText);
      return _react2.default.createElement(
        _reactMoleculeField2.default,
        {
          name: id,
          label: label,
          successText: successText,
          errorText: errorText,
          helpText: helpText,
          inline: inline,
          onClickLabel: handleClick
        },
        _react2.default.createElement(
          _reactMoleculeSelect2.default,
          (0, _extends3.default)({
            refMoleculeSelect: refSelect,
            errorState: errorState
          }, props),
          children
        )
      );
    }
  }]);
  return MoleculeSelectField;
}(_react.Component);

MoleculeSelectField.displayName = 'MoleculeSelectField';

MoleculeSelectField.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Text to be displayed as label */
  label: _propTypes2.default.string.isRequired,

  /** used as label for attribute and Select element id */
  id: _propTypes2.default.string.isRequired,

  /** Success message to display when success state  */
  successText: _propTypes2.default.string,

  /* onChange callback */
  onChange: _propTypes2.default.func,

  /** Error message to display when error state  */
  errorText: _propTypes2.default.string,

  /** Help Text to display */
  helpText: _propTypes2.default.string,

  /** Boolean to decide if elements should be set inline */
  inline: _propTypes2.default.bool
} : {} : {};

exports.default = MoleculeSelectField;